		TITLE   "E16-1-GW"
		LIST    P=16F84

INDIR   EQU     00H     ; Indirect pointer
RTCC    EQU     01H     ; Real time clock / counter
PCL     EQU     02H     ; Program counter low byte
STATUS  EQU     03H     ; Status register
CY      EQU     0       ; Carry/borrow bit
DC      EQU     1       ; Digit carry
Z	EQU     2       ; Zero flag
PD      EQU     3       ; Power down
T0      EQU     4       ; Time-out bit
RP0     EQU     5       ; Register page select bits
RP1     EQU     6       ; Not used in 16C84
RP2     EQU     7       ; Not used in 16C84
FSR     EQU     04H     ; Indirect pointer
PORTA   EQU     05H     ; PORT A
PORTB   EQU     06H     ; PORT B
EEDATA  EQU     08H     ; Eeprom data
EEADR   EQU     09H     ; Eeprom address
PCLATH  EQU     0AH     ; Program counter high byte
INTCON  EQU     0BH     ; Interrupt control
TRISA   EQU     085H    ; Data direction port A
TRISB   EQU     086H    ; Data direction port B
EECON1  EQU     088H    ; Eeprom control 1
RD	EQU	0	; Start reading from EEPROM
WR	EQU	1	; Start writing to EEPROM
WREN	EQU	2	; Eeprom write enable
EECON2	EQU	089H	; Eeprom control 2

W       EQU     0       ; W reg. as destination
F       EQU     1       ; F file as destination

	;  ६ :

	; 40h..45h - ᢮
	; 46h - 㪠⥫   CW
	; 47h -   ६⮬ 
	; 48h - TMP Delay       XXX
	; 49h - TMP Send/Recv   YYY
	; 4Ah - TMP 権  ZZZ
	; 4Bh -  -

	;0C..0F - ६. DES
	;10..1F -  DW
	;18..1F -  DES
	;20..27 -  
	;28..2F - ࠢ 
	;30..3F -   CW
	;40..4F - ६

	; ६ ᯮ 樨 :

	CW_PTR	EQU	46H
	REM_KEY	EQU	47H
	XXX	EQU	48H
	YYY	EQU	49H
	ZZZ	EQU	4AH
	CONSULT	EQU	4BH
	CLA	EQU	4FH
	INS	EQU	4CH
	P1	EQU	4DH
	P2	EQU	4EH
	P3	EQU	CLA

		ORG     0000H

		GOTO    Start

		ORG	0001H

		RETLW   024H		;1
		RETLW   002H		;2
		RETLW   004H		;3
		RETLW   006H		;4
		RETLW   0ACH		;5
		RETLW   0B8H		;6
		RETLW   0F0H		;7
		RETLW   018H		;8
		RETLW   0C0H		;9
;  - - /  -  
		RETLW   0A4H		;A
		RETLW   0F8H		;B
		RETLW   088H		;C

ATR		RETLW	0068h
		RETLW	0066h
		RETLW	0000h
		RETLW	0014h
		RETLW	0080h
		RETLW	0000h
		RETLW	0025h
		RETLW	0018h
		RETLW	0077h
		RETLW	003Fh

Start		CLRW
		CALL	Delay_7F	; W <- 7Fh
		OPTION			;    ⠭
		MOVLW   .10
_send_ATR	MOVWF   ZZZ		;뫪 ATR - 10 
		ADDLW	ATR-1
		CALL    W_PCL
		CALL    SEND		;W <- 7Fh
		CALL	StdDelay_7F
		DECFSZ  ZZZ,W
		GOTO    _send_ATR
Remote_Key	SWAPF	EEDATA,W
		ANDLW	0x30
		MOVWF	REM_KEY		;࠭塞  ६⭮ 
MainLoop	MOVLW   0x90		;뫪 ⢥ 90 0x
AltMainLoop	CALL    SEND
		RRF	PCLATH,W	;뤥塞  訡 
		ANDLW   0x08		; 뫠 00 (OK)  08 (Err)
		CALL    SEND
ReRead_Command	CALL    RECV		;⠥
		MOVWF   CLA		;  
		CALL    RECV		;⠥ 
		MOVWF   INS		; 
		CALL    RECV		;⠥
		MOVWF   P1		; P1
		CALL    RECV		;⠥
		MOVWF   P2		; P2
		INCFSZ	CLA,W		; ⠭   FF  ?
		GOTO	Baud_9600	; 㤥  115200  - Red CAM
		MOVF    CLA,W
		CALL    SEND
		MOVF    INS,W
		CALL    SEND
		MOVF    P1,W
		CALL    SEND
		MOVF    P2,W
		CALL    SEND
		BSF     INTCON,3	;⠢ 䫠 115200
		GOTO    ReRead_Command

Baud_9600	CALL    RECV		;⠥
		MOVWF   P3		; P3 - ⢮   뫪
		CLRF    PCLATH		;⪠ 䫠 訡
		MOVLW   .12		;ন 12 
_INS_scan	MOVWF	ZZZ		;  
		CALL    W_PCL		;  ⠡
		XORWF   INS,W
		BTFSC   STATUS,Z
		GOTO    CommandFound
		DECFSZ	ZZZ,W
		GOTO    _INS_scan
		MOVLW	0x6B
		GOTO	AltMainLoop	;  , 諥 6B 00

CommandFound	MOVF	ZZZ,W
		SUBLW	.9		;஢ઠ 
		MOVF	INS,W
		BTFSC	STATUS,CY	; 樨-⠭樨
		CALL	SEND		;⢥ত 뫪  
		MOVF	ZZZ,W		;୮ ⢫
		ADDLW   W_PCL		;   
W_PCL		MOVWF   PCL		;୮ ⢫
		GOTO    INS_CA24	;⢨, ⢥ত PIN-
		GOTO    INS_8702	;  ⥭  FAC
		MOVLW	@_06^_06^_04	;⥭    FAC (8704)
@_06		GOTO    INS_8704_8706	;⥭ ᮤন  FAC (8706)
		GOTO    INS_CAAC	;  
		GOTO    INS_CAB8	;⥭ 樨
		GOTO	INS_CA18_CAF0	; 樨 (CAF0)
		GOTO	INS_CA18_CAF0	; 祩 (CA18)
		GOTO    INS_CAC0	;⥭ ஢ ᫮
		GOTO    INS_CAA4	;롮 䠩/⠫
		GOTO    INS_CAF8	;
		;	INS_CA88	 । ஢ ᫮
INS_CA88	CALL    CryptoPreludeX8	; ५  ਯ⮣䨨
		CALL    Test_Nano	;ࠡ⪠  ; W <- 18h
		CALL    Move8_to_18	;஢ c 30h..37h  18h..1Fh
		CALL    DES		;஢ ࢮ ᫮ ; W <- 8
		MOVWF   EEADR		;஢ ࢮ .᫮
		CALL	Move4_		;  ᮢ 18h..1Fh   | ᫥ DES
		CALL    Move4_		;  ᠬ 10h..17h  | FSR = 18h
		MOVLW   020H		;஢  38h..3Fh  18h..1Fh
		CALL    Move8_to_18	;஢ ண .᫮
DES_MainLoop	CALL    DES		;஢ ண ᫮
		GOTO    MainLoop

INS_CAB8	BCF	STATUS,007H	; 䫠 "ࢠ CAB8"
		BTFSS   STATUS,06H	;஢ઠ 뫠  ।
		GOTO    _without_CAAC	; CAB8  CAAC
		BCF     STATUS,006H	; 䫠 "CAAC"
		BSF	STATUS,007H	;⠢ 䫠 "ࢠ CAB8"
		MOVF    CONSULT,W	; 樨
		CALL    DEC_SEND	;᫠   ⢥ত
		DECFSZ	P3,W		;஢ઠ   樨 = 1
_without_CAAC	BSF     PCLATH,4	;⠢ 䫠 訡
		MOVLW	Cons_A4
		BTFSS	CONSULT,0
		GOTO	SEND_CONSULT
		MOVLW	Cons_A5
		BTFSC	CONSULT,1
		MOVLW	Cons_A7
		GOTO	SEND_CONSULT

INS_CA24	MOVWF   4CH		;।᫥ ⠭   INS
		CALL    RECV		;᫥ ⠭   EEDATA
		DECFSZ  P3,F
		GOTO    INS_CA24
		DECFSZ	P1,W		;஢ઠ  CAA2401
		GOTO	MainLoop
		BTFSC	4CH,4		;⠭
		BSF	EEDATA,3	; 
		BTFSC	4CH,5		; ६⮬
		BSF	EEDATA,7	; 
		BTFSC	4CH,6		; ६⮬
		BSF	4CH,3		; 
		BTFSC	4CH,7		;஢ઠ    
		GOTO	Remote_Key
		MOVF	4CH,W
		ANDLW	0x0F
		ADDWF	REM_KEY,W	;࠭  
		MOVWF	EEADR
		BSF	STATUS,RP0
		BSF	EECON1,WREN
		MOVLW	0x55
		MOVWF	EECON2
		MOVLW	0xAA
		MOVWF	EECON2
		BSF	EECON1,WR
		BTFSC	EECON1,WR
		GOTO	$-1
		BCF	STATUS,RP0
		GOTO	MainLoop

INS_CAC0	BTFSS   P3,3		;  ஢ ᫮
		BTFSS	P3,4		; ⢮ 訢  - 12h
		GOTO    Send_ID_Entity	; ID   ᠭ entity
					; - 訢 03  1Ah 
					; EC-M 訢 04  06 
	;	BTFSS   P3,0		;  ஢ ᫮
	;	BTFSC   P3,3		; ⢮ 訢  - 12h
	;	GOTO    Send_ID_Entity	; ID   ᠭ entity
	;				; - 訢 03  1Ah 
		MOVLW   0xEA		;ਧ ᯥ譮 ஢
		CALL    DEC_SEND	
		MOVLW   0x10		;16  ஢ 
		MOVWF   FSR		; ᯮ  ᠬ 10h..1Fh
		CALL    DEC_SEND	
_send_encrypt	MOVF    INDIR,W		;᫠ ᫮,
		CALL    SEND
		INCF    FSR,F		; ஢
		DECFSZ  P3,F		; 
		GOTO    _send_encrypt	; CA88
		GOTO    MainLoop

CryptoPreludeX8	DECFSZ	P1,W		; CAx801 祭  ࠭
CryptoPreludeFX	CALL	Erase8_18	;  18h..1Fh
		BSF     INTCON,4	;⠢ 䫠 HASH
		SWAPF	P2,W
		ANDLW	0x30
		MOVWF	EEADR
		MOVLW	0x20		;⥭ 
		MOVWF	FSR		;  ᠬ 20h..2Fh
_load_KEY	BSF	STATUS,RP0
		BSF	EECON1,RD
		BCF	STATUS,RP0
		MOVF	EEDATA,W
		MOVWF	INDIR
		INCF	EEADR,F
		INCF	FSR,F
		BTFSS	FSR,4
		GOTO	_load_KEY
		MOVLW	0x30		;樠㥬 㪠⥫
		MOVWF   CW_PTR		;   ஢ ᫮
		GOTO	FSR_18h

Move4_0C_x	MOVWF   EEADR
		MOVLW   00CH
Move4		MOVWF   FSR		;஢ 4- 
Move4_		CALL    Move2
Move2		CALL    Move
Move		MOVF    INDIR,W		;஢ 
		MOVWF   EEDATA		; FSR -  筨
		MOVF    EEADR,W		; EEADR -  ७ 
		SUBWF   FSR,F
		MOVF    EEDATA,W
		MOVWF   INDIR
		INCF    EEADR,W
		ADDWF   FSR,F
		RETLW	0xF0		; W <- 0F0h

MULXOR		MOVLW	0x18^0x07
		MOVWF	FSR
		MOVF	YYY,W
		XORWF	FSR,F
		XORWF	ZZZ,W
		MOVWF	XXX
		MOVLW	0x07
		BTFSC	XXX,2
		XORWF	FSR,F
		BTFSC	XXX,2
		XORWF	XXX,F
		MOVF	YYY,W
		ANDLW	0x03
		XORWF	XXX,F
		ADDWF	XXX,F
		BTFSC	XXX,2
		RETLW	0x07			; W <- 7
		MOVF	INDIR,W
		MOVWF	RTCC
		MOVF	YYY,W
		ADDLW	0x28
		MOVWF	FSR
		MOVF	INDIR,W
		MOVWF	XXX
		MOVLW	0x04
		XORWF	FSR,F
		MOVLW	8
		MOVWF	4EH
		MOVF	INDIR,W
		CLRF    FSR		;Hi
_mul_8_		BTFSC	RTCC,0
		ADDWF   FSR,F		;Hi=+R[0]
		RRF     FSR,F		;Hi >>
		RRF     RTCC,F		;>> Lo
		DECFSZ  4EH,F
		GOTO    _mul_8_
		MOVF	ZZZ,W
		ADDLW	0x18
		MOVWF	FSR
		MOVF	RTCC,W
		XORWF	XXX,W
		XORWF	INDIR,F
		RETLW	0x07			; W <- 7

INS_CAF8	CALL    CryptoPreludeFX	; ५  ਯ⮣䨨
_recv_CAF8	CALL    InvSEND_RECV	;⠥  ᯮ㥬 ⮫쪮  
		CALL    Byte_Nano_W	;ࠡ  
		DECFSZ  P3,F
		GOTO    _recv_CAF8
		GOTO	DES_MainLoop	;⠥ 

Move8_to_18	MOVWF	EEADR		;஢ 8    18h..1Fh
		ADDLW	0x18
Move8		CALL    Move4		;஢ 8- 
		GOTO    Move4_

		ORG	100H-5

S_Box_Table_80	IORLW	040H
S_Box_Table_C0	IORLW	080H
S_Box_Table_40	XORLW	040H
S_Box_Table_00	CALL    W_PCL		; S-BOX
		MOVWF   EEDATA

		ORG	100H

		RETLW   0D7H		;00
		RETLW   01DH		;01
		RETLW   02DH		;02
		RETLW   0F8H		;03
		RETLW   08EH		;04
		RETLW   0DBH		;05
		RETLW   043H		;06
		RETLW   085H		;07
		RETLW   060H		;08
		RETLW   0A6H		;09
		RETLW   0F6H		;0A
		RETLW   03FH		;0B
		RETLW   0B9H		;0C
		RETLW   070H		;0D
		RETLW   01AH		;0E
		RETLW   043H		;0F
		RETLW   0A1H		;10
		RETLW   0C4H		;11
		RETLW   092H		;12
		RETLW   057H		;13
		RETLW   038H		;14
		RETLW   062H		;15
		RETLW   0E5H		;16
		RETLW   0BCH		;17
		RETLW   05BH		;18
		RETLW   001H		;19
		RETLW   00CH		;1A
		RETLW   0EAH		;1B
		RETLW   0C4H		;1C
		RETLW   09EH		;1D
		RETLW   07FH		;1E
		RETLW   029H		;1F
		RETLW   07AH		;20
		RETLW   023H		;21
		RETLW   0B6H		;22
		RETLW   01FH		;23
		RETLW   049H		;24
		RETLW   0E0H		;25
		RETLW   010H		;26
		RETLW   076H		;27
		RETLW   09CH		;28
		RETLW   04AH		;29
		RETLW   0CBH		;2A
		RETLW   0A1H		;2B
		RETLW   0E7H		;2C
		RETLW   08DH		;2D
		RETLW   02DH		;2E
		RETLW   0D8H		;2F
		RETLW   00FH		;30
		RETLW   0F9H		;31
		RETLW   061H		;32
		RETLW   0C4H		;33
		RETLW   0A3H		;34
		RETLW   095H		;35
		RETLW   0DEH		;36
		RETLW   00BH		;37
		RETLW   0F5H		;38
		RETLW   03CH		;39
		RETLW   032H		;3A
		RETLW   057H		;3B
		RETLW   058H		;3C
		RETLW   062H		;3D
		RETLW   084H		;3E
		RETLW   0BEH		;3F
		RETLW   04AH		;40
		RETLW   0DDH		;41
		RETLW   0B0H		;42
		RETLW   007H		;43
		RETLW   029H		;44
		RETLW   0B0H		;45
		RETLW   0EEH		;46
		RETLW   079H		;47
		RETLW   0F6H		;48
		RETLW   043H		;49
		RETLW   003H		;4A
		RETLW   094H		;4B
		RETLW   08FH		;4C
		RETLW   016H		;4D
		RETLW   0D5H		;4E
		RETLW   0AAH		;4F
		RETLW   031H		;50
		RETLW   0E2H		;51
		RETLW   0CDH		;52
		RETLW   038H		;53
		RETLW   09CH		;54
		RETLW   055H		;55
		RETLW   077H		;56
		RETLW   0CEH		;57
		RETLW   05BH		;58
		RETLW   02CH		;59
		RETLW   0A4H		;5A
		RETLW   0FBH		;5B
		RETLW   062H		;5C
		RETLW   08FH		;5D
		RETLW   018H		;5E
		RETLW   061H		;5F
		RETLW   01DH		;60
		RETLW   061H		;61
		RETLW   046H		;62
		RETLW   0BAH		;63
		RETLW   0B4H		;64
		RETLW   0DDH		;65
		RETLW   0D9H		;66
		RETLW   080H		;67
		RETLW   0C8H		;68
		RETLW   016H		;69
		RETLW   03FH		;6A
		RETLW   049H		;6B
		RETLW   073H		;6C
		RETLW   0A8H		;6D
		RETLW   0E0H		;6E
		RETLW   077H		;6F
		RETLW   0ABH		;70
		RETLW   094H		;71
		RETLW   0F1H		;72
		RETLW   05FH		;73
		RETLW   062H		;74
		RETLW   00EH		;75
		RETLW   08CH		;76
		RETLW   0F3H		;77
		RETLW   005H		;78
		RETLW   0EBH		;79
		RETLW   05AH		;7A
		RETLW   025H		;7B
		RETLW   09EH		;7C
		RETLW   032H		;7D
		RETLW   027H		;7E
		RETLW   0CCH		;7F

		RETLW	02Eh		;80
		RETLW	0E0h            ;81
		RETLW	0C4h            ;82
		RETLW	0BFh            ;83
		RETLW	04Dh            ;84
		RETLW	027h            ;85
		RETLW	011h            ;86
		RETLW	0C4h            ;87
		RETLW	072h            ;88
		RETLW	04Eh            ;89
		RETLW	0AFh            ;8A
		RETLW	072h            ;8B
		RETLW	0BBh            ;8C
		RETLW	0DDh            ;8D
		RETLW	068h            ;8E
		RETLW	011h            ;8F
		RETLW	083h            ;90
		RETLW	05Ah            ;91
		RETLW	05Ah            ;92
		RETLW	006h            ;93
		RETLW	036h            ;94
		RETLW	0FCh            ;95
		RETLW	0FCh            ;96
		RETLW	0ABh            ;97
		RETLW	0D5h            ;98
		RETLW	039h            ;99
		RETLW	009h            ;9A
		RETLW	095h            ;9B
		RETLW	0E0h            ;9C
		RETLW	083h            ;9D
		RETLW	097h            ;9E
		RETLW	068h            ;9F
		RETLW	044h            ;A0
		RETLW	0BFh            ;A1
		RETLW	021h            ;A2
		RETLW	08Ch            ;A3
		RETLW	01Eh            ;A4
		RETLW	0C8h            ;A5
		RETLW	0B8h            ;A6
		RETLW	072h            ;A7
		RETLW	0ADh            ;A8
		RETLW	014h            ;A9
		RETLW	0D6h            ;AA
		RETLW	0E9h            ;AB
		RETLW	072h            ;AC
		RETLW	021h            ;AD
		RETLW	08Bh            ;AE
		RETLW	0D7h            ;AF
		RETLW	0FFh            ;B0
		RETLW	065h            ;B1
		RETLW	09Ch            ;B2
		RETLW	0FBh            ;B3
		RETLW	0C9h            ;B4
		RETLW	003h            ;B5
		RETLW	057h            ;B6
		RETLW	09Eh            ;B7
		RETLW	063h            ;B8
		RETLW	0AAh            ;B9
		RETLW	03Ah            ;BA
		RETLW	040h            ;BB
		RETLW	005h            ;BC
		RETLW	056h            ;BD
		RETLW	0E0h            ;BE
		RETLW	03Dh            ;BF
		RETLW	0CFh            ;C0
		RETLW	0A3h            ;C1
		RETLW	011h            ;C2
		RETLW	0FDh            ;C3
		RETLW	0A8h            ;C4
		RETLW	044h            ;C5
		RETLW	0FEh            ;C6
		RETLW	027h            ;C7
		RETLW	096h            ;C8
		RETLW	07Fh            ;C9
		RETLW	02Bh            ;CA
		RETLW	0C2h            ;CB
		RETLW	063h            ;CC
		RETLW	098h            ;CD
		RETLW	084h            ;CE
		RETLW	05Eh            ;CF
		RETLW	009h            ;D0
		RETLW	06Ch            ;D1
		RETLW	0D7h            ;D2
		RETLW	010h            ;D3
		RETLW	032h            ;D4
		RETLW	0D1h            ;D5
		RETLW	04Dh            ;D6
		RETLW	0EAh            ;D7
		RETLW	0ECh            ;D8
		RETLW	006h            ;D9
		RETLW	070h            ;DA
		RETLW	0B9h            ;DB
		RETLW	055h            ;DC
		RETLW	03Bh            ;DD
		RETLW	0BAh            ;DE
		RETLW	085h            ;DF
		RETLW	090h            ;E0
		RETLW	04Dh            ;E1
		RETLW	0EEh            ;E2
		RETLW	038h            ;E3
		RETLW	0F7h            ;E4
		RETLW	02Ah            ;E5
		RETLW	05Bh            ;E6
		RETLW	0C1h            ;E7
		RETLW	02Ah            ;E8
		RETLW	093h            ;E9
		RETLW	084h            ;EA
		RETLW	05Fh            ;EB
		RETLW	0CDh            ;EC
		RETLW	0F4h            ;ED
		RETLW	031h            ;EE
		RETLW	0A2h            ;EF
		RETLW	075h            ;F0
		RETLW	0BBh            ;F1
		RETLW	008h            ;F2
		RETLW	0E6h            ;F3
		RETLW	04Ch            ;F4
		RETLW	017h            ;F5
		RETLW	0A6h            ;F6
		RETLW	07Ch            ;F7
		RETLW	019h            ;F8
		RETLW	060h            ;F9
		RETLW	0D3h            ;FA
		RETLW	005h            ;FB
		RETLW	0B2h            ;FC
		RETLW	08Eh            ;FD
		RETLW	06Fh            ;FE
		RETLW	0D9h            ;FF

		ORG	200H

		RETLW	004Ah		; PC2
		RETLW	0083h
		RETLW	0022h
		RETLW	001Bh
		RETLW	0081h
		RETLW	0089h
		RETLW	0021h
		RETLW	0014h
		RETLW	002Ah
		RETLW	0049h
		RETLW	008Bh
		RETLW	0042h
		RETLW	002Bh
		RETLW	0023h
		RETLW	0012h
		RETLW	0011h
		RETLW	0044h
		RETLW	0019h
		RETLW	001Ah
		RETLW	0029h
		RETLW	0024h
		RETLW	0013h
		RETLW	008Ah
		RETLW	0041h
		RETLW	0086h
		RETLW	0017h
		RETLW	002Ch
		RETLW	008Dh
		RETLW	002Eh
		RETLW	002Fh
		RETLW	004Ch
		RETLW	001Dh
		RETLW	0027h
		RETLW	008Eh
		RETLW	0085h
		RETLW	001Eh
		RETLW	0016h
		RETLW	0087h
		RETLW	002Dh
		RETLW	001Fh
		RETLW	0045h
		RETLW	008Fh
		RETLW	004Eh
		RETLW	0046h
		RETLW	0047h
		RETLW	0015h
		RETLW	008Ch
		RETLW	001Ch

ID_2		RETLW	0x01
		RETLW	0xA4
	;	RETLW	0x08

_04		RETLW	8		;	RETLW	7
		RETLW	0
		RETLW	0
		RETLW	0
		RETLW	.15
		RETLW	0
		RETLW	0
		RETLW	0

ID_1		RETLW	0xFF
		RETLW	0xF5
		RETLW	0x00

_06		RETLW	.15
		RETLW	10h
		RETLW	2
		RETLW	0CAh
		RETLW	20h
		RETLW	11h
Cons_A7		RETLW	9
		RETLW	'E'
		RETLW	't'
		RETLW	'h'
		RETLW	'e'
		RETLW	'r'
		RETLW	'e'
		RETLW	'a'
		RETLW	'l'
		RETLW	'+'

Entity		RETLW	.23-1
		RETLW	20h
		RETLW	0
		RETLW	0BFh
		RETLW	1Fh
		RETLW	80h
		RETLW	1Eh
		RETLW	80h
		RETLW	0
		RETLW	1
		RETLW	2
		RETLW	3
Cons_A5		RETLW	4
Cons_A4		RETLW	5
		RETLW	6
		RETLW	7
		RETLW	8
		RETLW	9
		RETLW	0Ah
		RETLW	0Bh
		RETLW	0Ch
		RETLW	0Dh
		RETLW	0Eh
	;;;	RETLW	0Fh
;
INS_CAA402	BTFSC	INTCON,6
		BSF	PCLATH,4	;⠢ 䫠 訡
		BSF	INTCON,6	;騩 - ஢
		GOTO	MainLoop

Table_Rnd	MOVWF	EEADR
		BSF	PCLATH,1
Table_Seq	MOVF	EEADR,W
		INCF	EEADR,F
		MOVWF	PCL

Erase8_18	CALL    FSR_18h		;18h -> FSR
_erase_		CLRF    INDIR		;㫨 ਯ⮡ 18h..1Fh
		INCF    FSR,F
		BTFSS   FSR,5
		GOTO    _erase_
		RETURN

INS_CAA4	BTFSC   P1,01H		;롮 ஢
		GOTO    INS_CAA402	;CAA402 - Next - ᫥饣
		BCF	INTCON,6	;騩 ஢ - 
		BTFSS   P1,02H
		GOTO    MainLoop	;CAA400 - ISSUER - ᠬ 孥
		;			 CAA404 - Select -   ID
INS_CAA404	MOVF    INS,W		;⢥ত 뫪  
		CALL    SEND_RECV	;⥭ 1-  ID
		INCFSZ	EEDATA,W
		BSF	INTCON,6	;騩 - ஢
		CALL    RECV		;⥭ 2-  ID
		CALL    RECV		;⥭ 3-  ID  W
		GOTO    MainLoop

INS_CAAC	MOVF    P1,W		; 樨
		MOVWF	CONSULT
		XORLW	0xA7		;A7
		BTFSS	STATUS,Z
		XORLW	0xA4^0xA7	;A4/A5 ?
		ANDLW	0xFE
		BTFSS	STATUS,Z
		GOTO	Wrong_Consult
		BSF     STATUS,6	;⠢ 䫠 "CAAC"
INS_CA18_CAF0
INS_8702	DECF    P3,F		;⠥ P3   塞
		BTFSC   P3,07H
		GOTO    MainLoop
		CALL    RECV
		BTFSS	INS,1		;祭 8702/CAAC/CA18/CAF0
		GOTO	INS_CA18_CAF0
		XORLW   0x40		;᫨ । P3  
		BTFSC   STATUS,Z	; 40h (next), 
Wrong_Consult	BSF     PCLATH,4	; ⠢塞 䫠 訡
		GOTO    INS_8702

Send_ID_Entity	MOVLW	ID_1
		BTFSC	INTCON,6	;/஢ ?
		MOVLW	ID_2
		CALL	Table_Rnd	; 뫪
		CALL	DEC_SEND	;
		CALL    Table_DEC_SEND	; ID-
		CALL    Table_DEC_SEND	; ஢
		MOVLW   @_06^_06^Entity	;ᠭ  (㭨ᠫ쭮)
INS_8704_8706	XORLW   @_06^_06	;8704 - ᠭ FAC 
					;8706 -  FAC 
		BCF	STATUS,7	; 䫠 "ࢠ CAB8"
SEND_CONSULT	CALL    Table_Rnd
		MOVWF   ZZZ		; ப
		DECF    P3,F
		BTFSC	STATUS,7	; 뫪 ࢨ筮 CAB8
_send_string	CALL    DEC_SEND	; ᫠ ᭠砫   ; W <- FFh
		BTFSC   P3,7		;᫠  P3 
		GOTO    MainLoop	;
	;	BTFSS	ZZZ,07H		;  뢠 ਯ⠬
		DECF    ZZZ,F		;᫨ 襭  ⮢,
		BTFSS   ZZZ,7		; 祬 ᮤন  ப, 
		CALL    Table_Seq	;  ⮪ FF-
		GOTO    _send_string

Test_Nano	BCF     INTCON,5	; 䫠 CRYPTED_DATA
		CALL    InvSEND_RECV
		MOVWF   4DH		; 
		XORLW   0xF0		; 
		BTFSC   STATUS,Z	;  F0 - ஢ 
		GOTO    Nano_F0
		CALL    Byte_Nano	;ࠡ  
		CALL    InvSEND_RECV
		MOVWF   4FH		; 
		CALL    Byte_Nano_W	;ࠡ  
		MOVF    4DH,W		; 
		XORLW   0xEA		; 
		BTFSC   STATUS,Z	;  EA - ஢ ᫮
		BSF     INTCON,5	;⠢ 䫠 CRYPTED_DATA
NanoData_Accept	DECF    4FH,F		;砥  , ⠥
		BTFSC   4FH,7		;   㪫뢠  , ᫨ 
		GOTO    Test_Nano	; ᫥饥 
		CALL    InvSEND_RECV
		CALL    CryptByte_Nano	;ࠡ  
		GOTO    NanoData_Accept

Nano_F0		CALL    DES		;⠥  ; FSR = 18h
		MOVF    INS,W		; , 뫠 
		CALL    SEND_RECV	;塞  ᨣ (8)
_signature_cmp_	CALL    RECV		;஢ઠ
		XORWF   INDIR,F		; ᮮ⢥⢨
		BTFSS   STATUS,Z	; ஢ 
		BSF     PCLATH,4	;⠢ 䫠 訡
		INCF    FSR,F		; ࠢ쭮
		BTFSS   FSR,5   	; ᨣ, ਯ⮡
		GOTO    _signature_cmp_	; 㤥 㫥 ( ᯮ)
		BCF     INTCON,4	; 䫠 HASH
		MOVF    27H,F		;᫥  
		BTFSC   STATUS,Z	;    ?
		RETLW	0x18		;᫨ ,  Eurocrypt-M ; W <- 18h
		MOVLW   2		;஢
		MOVWF   EEADR		; 8- 
		MOVLW   0x20		;  ᮢ 20h..27h
		CALL    Move8		;  ᠬ 1Eh..25h
		MOVF    1EH,W	;饭  ,
		MOVWF   25H	; ᯮ  ᠬ 20h..27h
		MOVF    1FH,W	; 0 1 2 3 4 5 6 7     -
		MOVWF   26H	; 2 3 4 5 6 0 1 7
		RETLW	0x18		; W <- 18h
		;  ᯮ  ஢  Viaccess

StdDelay_7F	MOVLW	.27		;⥫쭮   9600 
Delay_7F	MOVWF   XXX		;ந쭠 প,
		DECFSZ	XXX,F		;  ࠬ  W
		GOTO	$-1
		RETLW	0x7F		; W <- 7Fh

Table_DEC_SEND	CALL	Table_Seq	;뫪   ⠡
DEC_SEND	DECF    P3,F		;뫪   RS-232  㬥襭
;					; 稪 뫠 
SEND		MOVWF   EEDATA		;뫪   RS-232, EEDATA <- W
SEND_EEDATA	SWAPF	EEDATA,W	;  
		XORWF	EEDATA,W	; (⭮)
		MOVWF	YYY
		RRF	YYY,W
		XORWF	YYY,F
		BTFSC	YYY,2
		INCF	YYY,F
		RRF     YYY,F		; STATUS.CY  
		MOVLW	.14
		BTFSS   INTCON,3	;᫨ 115200,  ࢠ 
		MOVLW   .50+.28+.15
		CALL    Delay_7F	;⮢ ࢠ ; W <- 7Fh
		BCF     PORTB,7		;-
		TRIS    PORTB		; । ; TRIS 7FH
		MOVLW	9
		MOVWF   YYY
_send		BTFSS   INTCON,3	;᫨ 115200,   প
		CALL    StdDelay_7F
		COMF	EEDATA,W
		RLF     EEDATA,F
		MOVWF   PORTB		;W.7 -> PORTB.7
		DECFSZ  YYY,F
		GOTO    _send
		MOVLW   .28
		BTFSS   INTCON,3	;᫨ 115200,   প
		CALL    Delay_7F	; 
		MOVLW   0xFF		; (⮯   뫠)
TRIS_PORTB	TRIS    PORTB		; ਥ
		RETLW   0xFF		; W <- FFh

InvSEND_RECV	COMF    INS,W		;뫪 ᭮  ਥ
SEND_RECV	CALL    SEND		;뫪  ਥ
RECV		BTFSC   PORTB,7		;ਥ   RS-232
		GOTO    RECV
		MOVLW   .42
		BTFSS   INTCON,3	;᫨ 115200,   প
		CALL    Delay_7F
		MOVLW	9
		MOVWF	YYY
		GOTO	_recv
_recv		MOVF    PORTB,W		;PORTB.7 -> W.7
		SUBLW   0x7F		;Not(W.7) -> STATUS.CY
		RLF     EEDATA,F
		BTFSS   INTCON,3	;᫨ 115200,   প
		CALL    StdDelay_7F
		DECFSZ  YYY,F
		GOTO    _recv
		RRF     EEDATA,F	;  모
		MOVF    EEDATA,W
		RETURN			;⠢ 䫠 Z  १

DESX		MOVLW	0x07
		MOVWF	ZZZ
Loop_1		MOVWF	YYY
Loop_2		CALL	MULXOR		; W <- 7
		DECF	YYY,F
		BTFSC	YYY,2
		GOTO	Loop_2
		DECF	ZZZ,F
		BTFSS	ZZZ,7
		GOTO	Loop_1
		CLRF	ZZZ
Loop_3		CLRF	YYY
Loop_4		CALL	MULXOR
		INCF	YYY,F
		BTFSS	YYY,2
		GOTO	Loop_4
		INCF	ZZZ,F
		BTFSS	ZZZ,3
		GOTO	Loop_3
		RETLW	0x81

Rotate_SubKey	SWAPF	23H,W		;饭  
		ADDLW	080H		; 23h.3 -> STATUS.CY
		BCF	23H,003H
		RLF	26H,F
		RLF	25H,F
		RLF	24H,F
		RLF	23H,F
		RLF	22H,F
		RLF	21H,F
		RLF	20H,F
		BTFSC	STATUS,CY
		BSF	23H,004H
		RETLW	008H		; W <- 8

PC2_Expand_XOR	MOVWF   YYY		;PC2, Expansion Box  XOR 48-
		RRF     YYY,F		; १⮢   -  ࠧ
		RRF     YYY,W
PC2_Expand_XOR_	MOVWF   YYY
		INCF	PCLATH,F
		MOVLW   004H		; 6 ࠧ
		MOVWF   XXX
_pc2_		CALL	Table_Seq
		MOVWF	EEDATA
		ANDLW	0x07
		ADDLW   01FH
		MOVWF   FSR
		MOVF    INDIR,W
		BTFSC   EEDATA,03H	;訩  訩  ?
		SWAPF   INDIR,W		;᫨ 訩
		ANDWF   EEDATA,W	;뤥 㦭   
		ADDLW   0F0H		;஢   STATUS.CY
		RLF     XXX,F		;⠢塞  ⥫,
		BTFSS	STATUS,CY	;  ६ -
		GOTO    _pc2_		;  稪 横
		DECF	PCLATH,F
		MOVF    XXX,W
		XORWF   YYY,W
		ANDLW   03FH
		RETURN

CryptByte_Nano	BTFSS	INTCON,05H	;  䫠 CRYPTED_DATA
		GOTO	Byte_Nano_W	; ஢   
		MOVF    27H,W		;᫥  
		ANDLW   0F0H		;᫨   0000xxxx, 
		MOVLW   05AH		; ᪠ 5Ah,   ⨢ 砥 A5h
		BTFSS   STATUS,Z	; ᫨   , 
		MOVLW   0A5H		; xor- ஢ ᫮
		ANDWF   INDIR,W		;  襬 ᮢᥬ  
		BTFSS   27H,00H		;஢ઠ ⭮ 
		CLRW			; ⭮  祣  塞
		XORWF   EEDATA,W	; ⭮ xor-  襬
		MOVWF   RTCC		; ஢ ᫮
		MOVF    FSR,W		;६ ࠭塞 FSR
		MOVWF   4DH		;  4d
		MOVF    CW_PTR,W	;⥫   ஢ ᫮
		MOVWF   FSR		;뢠  ஢ ᫮
		MOVF    RTCC,W		;   
		MOVWF   INDIR		;㥬 祭   
		INCF    CW_PTR,F	;த 㪠⥫ 
		MOVF    4DH,W		;⠭ FSR
		MOVWF   FSR		;  4d
Byte_Nano	MOVF    EEDATA,W	;⠭  
Byte_Nano_W	XORWF   INDIR,F		;   楢 
		INCF    FSR,F
		BTFSS   FSR,05H		;   18h..1Fh ?
		RETURN
		;᫨  - ஢
; DES -      
;  室 :  㥬  㥬  - 18h..1Fh L,R
;              ஢ - 20h..27h
;  室 :  ஢    18h..1Fh, 
;             18h..1Bh-LEFT_HALF 1Ch..1Fh-RIGHT_HALF
DES		MOVLW	060H		; 稪
		CALL	SEND		; ⠩-
		CALL	DESX		; W <- 81h
	;;;	MOVLW	081H		; ᫠ 饭   :
		MOVWF	4EH		; 1 1 2 2 2 2 2 2 1 2 2 2 2 2 2 1
		MOVLW	0C0H		;   稪
		MOVWF	RTCC		; 16- 権
		BSF	PCLATH,0
		GOTO	_rotate_once	; ࢮ 樨 頥 1 ࠧ

DES_Iteration	MOVLW   0x04		;஢ 4- 
		MOVWF   EEADR		;  ᮢ 1Ch..1Fh
		MOVLW   0x1C		;  ᠬ 18h..1Bh
		CALL    Move4		;஥ R    L ; W <- F0h
		CALL    Move4_0C_x	;㥬 0Ch..0Fh  1Ch..1Fh
					; .  R    ; CY <- 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		RLF	4EH,F		; 
		RLF	RTCC,F
		BTFSS	RTCC,07H	;1,2,9,16-  - 頥  ࠧ
		CALL    Rotate_SubKey
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		MOVF	RTCC,W		; ᫠ 饭   :
;		SUBLW	00EH		; 1 1 2 2 2 2 2 2 1 2 2 2 2 2 2 1
;		XORLW	006H
;		BTFSC	STATUS,CY
;		BTFSC	STATUS,Z
;		GOTO	_rotate_once	;1,2,9-  - 頥  ࠧ
;		DECFSZ	RTCC,W		;஢ઠ  ᫥ 
;		CALL    Rotate_SubKey
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		DECF	RTCC,W		; 樨  ᬥ饭  ⠡
;		BTFSS   RTCC,03H	;- e d c b a 9 8 7 d c b a 9 8 7
;		ADDLW   007H		; ⮬  -  ᫠ 饭
;		CALL    S_Box_Table_00	;1 1 2 2 2 2 2 2 1 2 2 2 2 2 2 1
;		BTFSC   EEDATA,05H	;᫨   㪠뢠  
;		CALL    Rotate_SubKey	; 饭,  頥 ⥫쭮
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_rotate_once	CALL    Rotate_SubKey	;頥   ; W <- 8
		MOVWF   0EH		;16 <- 8
		MOVF    27H,W		;Key[7]
		MOVWF   0FH		;Key7tmp
		CLRF    0CH		;Hi
		MOVF    1CH,W		;R[0]  室 横
_mul_		RRF     0FH,F		;Key7tmp
		BTFSC   STATUS,CY
		ADDWF   0CH,F		;Hi=+R[0]
		RRF     0CH,F		;Hi >>
		RRF     ZZZ,F		;>> Lo
		DECFSZ  0EH,F		; 16   ⮬
		GOTO    _mul_
		ADDWF   27H,W		;R[0]+Key[7]
		BTFSC   STATUS,CY
		INCF    0CH,F		; ७  Hi
		ADDWF   ZZZ,F		;Lo += R[0]+Key[7]
		BTFSC   STATUS,CY
		INCF    0CH,F		;७  Hi
		MOVF    0CH,W		;Hi
		SUBWF   ZZZ,F		;Lo -= Hi
		BTFSS   STATUS,CY
		INCF    ZZZ,F		;Lo+, 稫 New R[0]
		CLRF    0CH		;塞  ஢ 
		CLRF	0DH
		CLRF    0FH		; Eh 㦥 㫥
		CLRF	EEADR		;  200h - ⠡ PC2

		RRF     1FH,W
		RRF     ZZZ,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_80
		BTFSC   EEDATA,03H
		BSF     0DH,007H
		BTFSC   EEDATA,02H
		BSF     0EH,007H
		BTFSC   EEDATA,01H
		BSF     0EH,001H
		BTFSC   EEDATA,00H
		BSF     0FH,001H

		RLF     1DH,W
		RLF     ZZZ,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_C0
		BTFSC   EEDATA,03H
		BSF     0DH,003H
		BTFSC   EEDATA,02H
		BSF     0FH,004H
		BTFSC   EEDATA,01H
		BSF     0CH,006H
		BTFSC   EEDATA,00H
		BSF     0EH,006H

		RRF     ZZZ,W
		RRF     1DH,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_40
		BTFSC   EEDATA,03H
		BSF     0EH,000H
		BTFSC   EEDATA,02H
		BSF     0DH,000H
		BTFSC   EEDATA,01H
		BSF     0FH,002H
		BTFSC   EEDATA,00H
		BSF     0CH,002H

		RLF     1EH,W
		RLF     1DH,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_00
		BTFSC   EEDATA,03H
		BSF     0FH,006H
		BTFSC   EEDATA,02H
		BSF     0EH,004H
		BTFSC   EEDATA,01H
		BSF     0DH,006H
		BTFSC   EEDATA,00H
		BSF     0CH,007H

		RRF     1DH,W
		RRF     1EH,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_80
		BTFSC   EEDATA,07H
		BSF     0CH,000H
		BTFSC   EEDATA,06H
		BSF     0DH,002H
		BTFSC   EEDATA,05H
		BSF     0FH,007H
		BTFSC   EEDATA,04H
		BSF     0CH,005H

		RLF     1FH,W
		RLF     1EH,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_C0
		BTFSC   EEDATA,07H
		BSF     0CH,004H
		BTFSC   EEDATA,06H
		BSF     0FH,003H
		BTFSC   EEDATA,05H
		BSF     0DH,005H
		BTFSC   EEDATA,04H
		BSF     0EH,005H

		RRF     1EH,W
		RRF     1FH,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_40
		BTFSC   EEDATA,07H
		BSF     0FH,000H
		BTFSC   EEDATA,06H
		BSF     0DH,004H
		BTFSC   EEDATA,05H
		BSF     0EH,002H
		BTFSC   EEDATA,04H
		BSF     0CH,001H

		RLF     ZZZ,W
		RLF     1FH,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_00
		BTFSC   EEDATA,07H
		BSF     0CH,003H
		BTFSC   EEDATA,06H
		BSF     0FH,005H
		BTFSC   EEDATA,05H
		BSF     0DH,001H
		BTFSC   EEDATA,04H
		BSF     0EH,003H

		MOVF    0CH,W		;᫨ 䫠 HASH
		XORWF   0DH,W		; ⠢,
		BTFSS	INTCON,4	;  
		CLRW			; ⠬
		XORWF   0DH,F		; ᮤন 0C  0D
		XORWF   18H,W		;XOR ஥ L
		XORWF   0CH,F		;  ᮢ 18h..1Bh
		MOVF    19H,W		;
		XORWF   0DH,F		; ᢥ
		MOVF    1AH,W		;  १
		XORWF   0EH,F		;
		MOVF    1BH,W		; ஢   R  
		XORWF   0FH,F		;   0Ch..0Fh -  R
		INCFSZ	RTCC,W  	; ᫥   ?
		GOTO    DES_Iteration
; ᫥ 樨 ⠭  , ⮬ १ - 4L 4L 4R
		MOVLW   0F4H
		CALL    Move4_0C_x	;뫪 0Ch..0Fh -> 18h..1Bh
		CALL	DESX
		; 砫 楢  
FSR_18h		MOVLW   018H		; FSR <- 18h
		MOVWF   FSR
		RETLW	0x08		; W <- 8

		ORG	2007H

		DATA	3FF9h

		ORG	2100H

Key_8_C		DATA	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
Key_9_D		DATA	04Fh,084h,0B6h,038h,030h,001h,0F1h,0A9h
		DATA	062h,027h,0C3h,01Ah,09Dh,016h,0DFh,019h
Key_A_E		DATA	03Dh,044h,034h,0E7h,03Dh,0D2h,0BCh,0A1h
		DATA	009h,078h,06Dh,011h,06Ch,0C6h,028h,0E7h
Key_B_F		DATA	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0

		END
